---
marp: true
theme: gaia
class: [lead, invert]
---
# KSZKépzés Linux
Tóth Miklós

---
<!-- class: [invert] --> 

## Mi is a Linux?

- kernel
    - de! GNU/Linux már OS
- disztrók
- GUI
- CLI

---

## CLI

*Command Line Interface*

- terminál
- shell
    - sh
    - bash
    - zsh
    - fish

---

## Shelles fogalmak

- kapcsolók `rm -rf`
- redirekció `ls > fajllista.txt`
- piping `cat alma.txt | grep körte`
- shell execution `echo a mappa tartalma: $(ls)`

---

## Szövegszerkesztők

- nano
- vi, vim, nvim

---

## Gyakori parancsok

- ls
- man
- cat
- echo
- cd
- mkdir
- rm
- rmdir
- touch

---

## Csomagkezelés

- Mi a csomag?
- Hogyan telepítünk programokat Linuxon?
- Miért jó ez?
- Hogy működik az `apt`?

---

## Fájlkezelés

- `/` jel van `\` helyett
- nincs `C:\`, hanem `/`-ből indul minden
- `/etc`, `/dev`, `/home`, `/bin`, `/lib`, `/proc`, stb.
- `../`, `./`, `~`, `~bela`

---

## Jogosultságok

- `user`, `group`, `others`
- `rwx` hármasok
- `setuid`, `setgid`, `sticky bit`
- `chmod`, `chown`, `chgrp`

---

## UNIX elvek

- KISS
- Everything is a file

---

## Architektúra

- Bootloader
- Kernel
- Init rendszer
- "Userland"

---

## Felhasználókezelés

- `useradd`, `usermod`, `userdel`
- (`adduser`, `deluser`)
- `passwd`
- `sudo`

---

## Csoportok

- `groups`
- `groupadd`, `groupdel`
- `usermod`
- `gpasswd`

---

## Init rendszer, systemd

- Miért?
- Mi egy service?
- systemctl
- journalctl

---

## Hálózat

- `ip address`, `ip addr add`
- `ip route`, `ip route add`
- hálózatkezelők, `NetworkManager`

---

## SSH

- secure remote shell
- kulcsok
- sok egyéb okos feature

---
<!-- class: [lead, invert] --> 

# Kahoot!

---

# Workshop time!

---

<!-- class: [invert] --> 

## 1. feladat

Telepíts fel egy apache2 webszervert és állítsd be, hogy egy mappában lévő szkripteket lefuttasson és kimenetüket leküldje!

---

```sh 
sudo ln -s /etc/apache2/mods-available/cgi.load /etc/apache2/mods-enabled/
```

```sh 
sudo nano /etc/apache2/sites-enabled/000-default.conf
```

```
<VirtualHost *:80>
   [...]
   <Directory "/var/www/html/scripts">
     AllowOverride None
     Require all granted
     Options +ExecCGI
     AddHandler cgi-script .cgi .pl .py .sh
   </Directory>
   DocumentRoot /var/www/html
   [...]
</VirtualHost>
```

---

```sh
#!/bin/bash

echo Content-type: text/html
echo
echo hello world
```

---

## 2. Feladat

- Nézzük meg milyen userként fut a webszerver!
- Csináljunk egy oldalt, ami kiírja az időt és azt, hogy hány user van belépve!
- Csináljunk egy oldalt, ami kiírja, hogy hányadik hét van!
    - hint: `jq`, https://hanyadikhetvan.attiss.eu/api